unofficial mirror of notmuch@notmuchmail.org
 help / color / mirror / code / Atom feed
From: David Bremner <david@tethera.net>
To: notmuch@notmuchmail.org
Cc: David Bremner <david@tethera.net>
Subject: [PATCH 3/7] test: add test_expect_equal_file_nonempty
Date: Wed,  4 Aug 2021 07:42:32 -0300	[thread overview]
Message-ID: <20210804104236.3986362-4-david@tethera.net> (raw)
In-Reply-To: <20210804104236.3986362-1-david@tethera.net>

A common bug in tests is that the code used to generate the EXPECTED
file fails, generating no output. When the code generating the OUTPUT
file fails in the same way, the test passes, even though there is a
failure being hidden. Add a new test function that guards against
this.
---
 test/test-lib.sh | 20 ++++++++++++++++++++
 1 file changed, 20 insertions(+)

diff --git a/test/test-lib.sh b/test/test-lib.sh
index 6f4bb47f..dc4962f5 100644
--- a/test/test-lib.sh
+++ b/test/test-lib.sh
@@ -434,6 +434,26 @@ test_expect_equal_file () {
     test_diff_file_ "$1" "$2"
 }
 
+# Like test_expect_equal, but takes two filenames. Fails if either is empty
+test_expect_equal_file_nonempty () {
+    exec 1>&6 2>&7		# Restore stdout and stderr
+    if [ -z "$inside_subtest" ]; then
+	error "bug in the test script: test_expect_equal_file_nonempty without test_begin_subtest"
+    fi
+    inside_subtest=
+    test "$#" = 2 ||
+	error "bug in the test script: not 2 parameters to test_expect_equal_file_nonempty"
+
+    for file in "$1" "$2"; do
+	if [ ! -s "$file" ]; then
+	    test_failure_ "Missing or zero length file: $file"
+	    return $?
+	fi
+    done
+
+    test_diff_file_ "$1" "$2"
+}
+
 # Like test_expect_equal, but arguments are JSON expressions to be
 # canonicalized before diff'ing.  If an argument cannot be parsed, it
 # is used unchanged so that there's something to diff against.
-- 
2.30.2

  parent reply	other threads:[~2021-08-04 10:43 UTC|newest]

Thread overview: 11+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2021-08-04 10:42 v2 look in MAILDIR for database David Bremner
2021-08-04 10:42 ` [PATCH 1/7] test/expect_equal_file: whitespace cleanup David Bremner
2021-08-22  2:44   ` David Bremner
2021-08-04 10:42 ` [PATCH 2/7] test: factor out test_diff_file_ David Bremner
2021-08-04 10:42 ` David Bremner [this message]
2021-08-04 10:42 ` [PATCH 4/7] test/path-config: use test_expect_equal_file_nonempty David Bremner
2021-08-21 20:41   ` Tomi Ollila
2021-08-04 10:42 ` [PATCH 5/7] test: add known broken tests for finding database via MAILDIR David Bremner
2021-08-04 10:42 ` [PATCH 6/7] lib/open: look in MAILDIR for database, as documented David Bremner
2021-08-04 10:42 ` [PATCH 7/7] doc: document database search algorithm David Bremner
2021-08-21 15:03   ` David Bremner

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

  List information: https://notmuchmail.org/

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20210804104236.3986362-4-david@tethera.net \
    --to=david@tethera.net \
    --cc=notmuch@notmuchmail.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
Code repositories for project(s) associated with this public inbox

	https://yhetil.org/notmuch.git/

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).